`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// 
// Create Date:    15:19:17 09/18/2015 
// 
// Module Name:    bin2bcd 
// Project Name: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module bin2bcd
	(
    input [7:0] bin,
    output reg [3:0] d100,
    output reg [3:0] d10,
    output reg [3:0] d1
	);
integer i;
always @(bin) 
	begin
// reset to zero
    d100 = 4'd0;	// hundreds
    d10 = 4'd0;	// tens
    d1 = 4'd0;		// ones

    for (i=7; i>=0; i=i-1) begin
// add 3 to columns >= 5
        if (d100 >= 5)
            d100 = d100 + 3;
        if (d10 >= 5)
            d10 = d10 + 3;
        if (d1 >= 5)
            d1 = d1 + 3;
// shift left one
        d100 = d100 << 1;
        d100[0] = d10[3];
        d10 = d10 << 1;
        d10[0] = d1[3];
        d1 = d1 << 1;
        d1[0] = bin[i];
    end
end
endmodule


